//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
//
using System;

namespace Testing
{
	class Complex
	{
		protected double real;
		protected double imag;
		public override string ToString()
		{
			return (string.Format("({0}, {1}i)", real, imag));
		}
		
    public static bool operator==(Complex a, Complex b)
    {
        if(a.real == b.real &&
           a.imag == b.imag)
        {
            return(true);
        }
        else
        {
            return(false);
        }
    }
    public static bool operator!=(Complex a, Complex b)
    {
        return(!(a == b));
    }
    public override bool Equals(object o)
    {
        Complex b = (Complex)o;
        return(this == b);
    }
    public override int GetHashCode()
    {
    	return (real.GetHashCode() ^ imag.GetHashCode());
    }
    public static Complex operator+(Complex a, Complex b)
    {
    	Complex r = new Complex();
	r.real = a.real + b.real;
	r.imag = a.imag + b.imag;
	return(r);
    }
		public double Real
		{
			get
			{
				return real;
			}
			set
			{
				real = value;
			}
		}
		public double Imaginary
		{
			get
			{
				return imag;
			}
			set
			{
				imag = value;
			}
		}
	}
	
	class Polar: Complex
	{
		public double Magnitude
		{
			get
			{
				return Math.Sqrt(real*real + imag*imag);
			}
		}
		public double Phase
		{
			get
			{
				return Math.Atan2(imag,real);
			}
		}
	}
	
	class HelloMain
	{
	        static void ComplexOutput(object o)
		{
			Complex cn = (Complex)o;
			Console.WriteLine("{0}", cn);
		}
		static void Main(string[] args)
		{
			Complex cn = new Complex();
			cn.Real = 1;
			cn.Imaginary = 0;
			Console.WriteLine("{0}", cn);
			Complex cna = new Complex();
			cna.Real = 1;
			cna.Imaginary = 0;
			Complex cnb = new Complex();
			cnb.Real = 0;
			cnb.Imaginary = 1;
			Console.WriteLine("{0} {1} {2}", cna == cnb, cna.Equals(cnb), cna != cnb);
			Console.WriteLine("{0}", cna + cnb);
		}
	}
}
